
/*
* $Log$
* Revision 2.2  2004/02/18 19:26:17  richq
* Armies either belong to a character or to a fortress/city (analogous to
* garrisons in LoM) Loyalty, race, size and energy depend on the owner of the army
* and whether it is in a Fortress or "travelling" with the character.
*
* Revision 2.1.1.1  2004/02/04 21:49:21  Default
* Doomdark's Revenge GBA
*
*                                              
*/

#ifndef _army_h
#define _army_h

#include "gba.h"
#include "location.h"

typedef struct {
  u8 size;        // table 7
  u8 owner;       // table 9
} garrison_t;

extern garrison_t * g_garrisons;

typedef struct {
  u8 size;        // table 6
  u8 lost;        // table 5
  u8 slew;        // table 4
  u8 race;        // table 8
} chararmy_t;

extern chararmy_t * g_charArmies;

extern int g_garrisonHere;

void init_army(void);
void calculateGarrisonAt(const location_t * pos);

int getArmyRace(int armyid);
int getArmyLoyalty(int armyid);
int getArmySize(int armyid);
int getArmyEnergy(int armyid);

void setArmySize(int armyid, int newSize);

// add warriors/riders token depending on race
void addArmyTypeTokens(int army);
void addArmySizeAndType(int id);

void createCharArmyReport(int who);

#endif

