/*
* $Log$
* Revision 2.4  2006/07/30 11:38:47  rich
* Changes to take new gbalib fixes into account
*
* Revision 2.3  2004-02-22 15:20:18  richq
* Tidying up after gameover. Sorted missing prototype warnings.
*
* Revision 2.2  2004/02/18 19:16:16  richq
* Almost the same as LoM. Initialisation and main loop.
*
* Revision 2.1.1.1  2004/02/04 21:49:20  Default
* Doomdark's Revenge GBA
*
*
*/

#include "gba.h"
#include "screenmode.h"
#include "interrupts.h"
#include "sprite.h"

#include "location.h"
#include "characters.h"
#include "gfx.h"
#include "input.h"
#include "inter.h"
#include "location.h"
#include "savearea.h"
#include "tokens.h"
#include "look.h"
#include "army.h"
#include "main.h"
#include "flames.h"
#include "guidance.h"
#include "objects.h"

globals_t g_status;

void Setup(void);
void showSplash(void);
void (*IntrTable[])() = {
  0, // v-blank
  0, // h-blank
  0, // vcount
  0, // timer0
  0, // timer1
  0, // timer2
  0, // timer3
  0, // serial
  0, // dma0
  0, // dma1
  0, // dma2
  0, // dma3
  0, // key
  0  // cart
};

int main(void)
{
  clear_vram();
  init_interrupts(INT_VBLANK, VBlankInterruptHandler);
  while (1) {
    showSplash();
    clear_vram();
    Setup();
    g_status.screen = LOOK_SCREEN;
    extern int l_horizon_set;
    l_horizon_set = 0;
    set_horizon();
    look();
    
    
    fade_up();
    g_gameover = 0;
    while(g_gameover == 0) {  
      handle_keys();
      wait_vsync_int();
      redrawFlames();
    }
    // clear bottom screen
    remove_sprite(0);
    clear_objects();
    fade_down();
    clear_vram();
  }
  
}



void Setup(void) {
  
  SetMode(MODE_0 | OBJ_ENABLE | OBJ_MAP_1D);
  
  // set all the sprites to "not for processing" state
  u16 loop;
  for(loop = 0; loop < 128; loop++)  {
    remove_sprite(loop);
  }
  CopyOAM();
  
  // initialise the various buffers, data sets, etc
  init_map();
  init_army();
  init_characters();
  init_gfxbuffer();
  init_savearea();
  init_token_buffers();
  init_backgrounds();
  init_guidance();
  load_font();
    
}
