/*
* $Log$
* Revision 2.2  2004/02/18 19:15:34  richq
* Unchanged from LoM. GBA-specific menu selection stuff.
*
* Revision 2.1.1.1  2004/02/04 21:49:20  Default
* Doomdark's Revenge GBA
*
* 
*/

#include "gba.h"
#include "gfx.h"

#include "menu.h"

// where the sprite is in oam
#define HIGHLIGHT_SPRITE 7
#define HIGHLIGHT_PRIORITY 1
#define HIGHLIGHT_X 1

int g_highlightOn;

void createHighlightTiles(void) {
  
  u8 tileBuffer[8*8];
  int i, j;
  for (i = 0; i < 8; i++)
    for (j = 0; j < 8; j++) 
      tileBuffer[i+j*8] = (i==0||j==7)?0:32+2; // blue
  
  drawImage(tileBuffer,0, 0, HIGHLIGHT_SPRITE);

  // set between text and bg..
  init_sprite64(HIGHLIGHT_SPRITE, HIGHLIGHT_PRIORITY);
  g_highlightOn = 1;
  
  // now alpha blend between the highlighter and the text layer
  REG_BLDMOD = BLDMOD_FIRST_BG2|BLDMOD_FIRST_BG1 | BLDMOD_SECOND_OBJ | BLDMOD_MODE(1);
  REG_COLEV = (12)|((4)<<8);
  
}

void moveHighlighter(int x, int y) {
  
  // the highlight sprite...
  if (!g_highlightOn)
    createHighlightTiles();
  
  move_sprite(HIGHLIGHT_SPRITE, x*8, y*8);
  
}

void clearHighlighter(void) {
  g_highlightOn = 0;
  remove_sprite(HIGHLIGHT_SPRITE);
  CopyOAM();
  //REG_BLDMOD = 0;
}

void getChoiceXY(int choice, int *x, int *y) {
  
  // look for # characters in the text map at x = 1
  int choicey = 0;
  int choicex = 0x1;

  choice++;
  int found = 0;
  int tileID = (FONT_TILE - 0x20 );
  
  while (choice > found && choicey <= 20) {
    
    if ( ( (bg_text.mapData[choicex+choicey*32]&255) ==  (tileID+ASCII_BOX_OK)) || 
         ( (bg_text.mapData[choicex+choicey*32]&255) ==  (tileID+ASCII_BOX_DEAD)) || 
         ( (bg_text.mapData[choicex+choicey*32]&255) ==  (tileID+ASCII_BOX_TIRED)) || 
         ( (bg_text.mapData[choicex+choicey*32]&255) ==  (tileID+ASCII_BOX_NIGHT))
       ) {
      
      found++;
    }
    choicey++;
    if (choicey == 0x13 && choicex == 1) {
      choicex = 0x10;
      choicey = 0;
    }
    
  }
  *y = choicey - 1;
  *x = choicex;
  
}

void selectOption(int i) {
  int x, y;
  getChoiceXY(i, &x, &y);
  moveHighlighter(x, y);
}


