/*
* $Log$
* Revision 2.3  2004/02/22 15:03:54  richq
* Transparency for map screen
*
* Revision 2.2  2004/02/18 19:14:28  richq
* Draws the creatures and characters ahead of us. Apart from some extra
* attribute fiddling, is unchanged from LoM. Also has routines for handling
* the effect of "objects" - like Claws of Death, Wild Horses, etc.
*
* Revision 2.1.1.1  2004/02/04 21:49:21  Default
* Doomdark's Revenge GBA
*
*                                                                         
*/


#ifndef OBJECTS_H
#define OBJECTS_H

#include "location.h"

#define COLOURTYPE_DAY     0
#define COLOURTYPE_DAWN    1
#define COLOURTYPE_INFO    2
#define COLOURTYPE_NIGHT   3
#define COLOURTYPE_VIEW    4
#define COLOURTYPE_TUNNEL  5

#define GFX_LUXOR_HORSE     0
#define GFX_LUXOR           1
#define GFX_MORKIN_HORSE    2
#define GFX_MORKIN          3
#define GFX_RORTHRON_HORSE  4
#define GFX_RORTHRON        5
#define GFX_FEY_HORSE       6
#define GFX_FEY             7
#define GFX_BARBARIAN_HORSE 8
#define GFX_BARBARIAN       9
#define GFX_ICELORD_HORSE   10
#define GFX_ICELORD         11
#define GFX_TARITHEL        12
#define GFX_GIANT           13
#define GFX_SHARETH         14
#define GFX_DWARF           15
#define GFX_DRAGON          16
#define GFX_WOLF            17
#define GFX_TROLL           18
#define GFX_SKULKRIN        19
#define GFX_HORSE           20

#define OBJECT_DRAGONS      0 
#define OBJECT_WOLVES       1 
#define OBJECT_TROLLS       2 
#define OBJECT_SKULKRIN     3 
#define OBJECT_WILD_HORSES  4 
#define OBJECT_GUIDANCE     5 
#define OBJECT_SHELTER      6 
#define OBJECT_CLAWS        7 
#define OBJECT_FLAMES       8 
#define OBJECT_THORNS       9 
#define OBJECT_BLOOD        10
#define OBJECT_LANGUOR      11
#define OBJECT_SPRINGS      12
#define OBJECT_NOTHING      13

#define OBJECT_EMPTY      255
//#define OBJECT_
//#define OBJECT_

// sprite definitions
#define SHIELD_SPRITE -1
#define OBJECT_SPRITE 1
#define MAX_OBJECTS 6

extern int g_colourType;

void activateObject(int thing_here);

//
void drawInFront(int colourType);
void clear_objects(void);


void thinkAboutObjects(void);

void setObjectHere(void);

// loads the object palette, bright colours first, then non bright ones
// bright colours start at OBJECT_PAL_OFFSET, 
// non bright ones at OBJECT_PAL_OFFSET+16
void set_object_palette(void/*int colourType*/);

int calculateObject(const location_t * pos);

void drawCharGfx(int glyph, int x, int basey, int colourType);

void remove_shield(void);

void describeObjects(void);

void drawGFX(int id, int x, int y, int sprite);

#endif

